%stft_func.m
%script that performs the STFT on an audio signal and calls other functions
%that auto-tune the signal

[f fs nbits] = wavread('input_file.wav');	%get input file
f = f';			%transpose it for correct processing
fl = numel(f);	

window_size = 1024;		%set window size to typical value of 1024
hopsize = window_size/4;	%jump size is N/4 for hanning window
window = hann(window_size)';

iter = 1;
for pos = 1:hopsize:fl-hopsize	%loop through windowing
	if (pos+window_size < fl)
		windowed_f = f(pos:(pos + window_size - 1));	%get desired samplings

		short_f = windowed_f.*window/2;		%multiply by window and scale
		fm_mat(iter, :) = (fft(short_f));;	
		iter = iter + 1
	end
end

%run other functions to manipulate coefficients
pv_fm = pv_func(fm_mat,hopsize);
tuned_fm = tuner(pv_fm);
tuned_f = istft_func(fm_mat,hopsize);

%write new file to output
wavwrite(tuned_f ,44100,'output_test2.wav');