function sig = tuner(fm_mat)
%function that corrects the pitch of an off-key voice
%Inputs:	fm_mat - the matrix of STFT coefficients
%			window_size - 

tones = get_scale();

%get dimenaions of matrix
s = size(fm_mat);
num_iter = s(1);
fm_len = s(2);

%generate coefficient frequencies
window_size = 1024;
freqs = (1:fm_len)*44100/window_size;

k = 1;
for i = 1:num_iter
	freqs = freqs(find(freqs<tones(end)));
	fm_curr = fm_mat(i,2:numel(freqs));
	[val num] = max(abs(fm_curr));
	freq = freqs(num);
	
	%loop until find the nearest musical frequency
	while tones(k) < freq		
		k = k + 1;
	end
	
	%determine which is the closest frequency
	if abs(tones(k-1)-freq) < abs(tones(k)-freq)
		pha = tones(k-1)-freq;
	else
		pha = tones(k)-freq;
	end
	%shift the phase to tune to that frequency
	fm_mat(i,:) = exp(1*i*pha)*fm_mat(i,:);
end
		
sig = fm_mat;	%output the new coefficients